/*      cparr.c
**
** These routines copy one three dimensional array to another using various
** memory referencing methods.
*/


#define DIM_SIZE        10

static char s[DIM_SIZE][DIM_SIZE][DIM_SIZE];
static char d[DIM_SIZE][DIM_SIZE][DIM_SIZE];



/*
**      -- standard array indexing.
*/

int cparr (cnt)
        int cnt;
        {
        int i;
        register int j, k;

        timestart ();
        for (  ;  cnt;  cnt--)
                for (i = 0;  i < DIM_SIZE;  i++)
                        for (j = 0;  j < DIM_SIZE;  j++)
                                for (k = 0;  k < DIM_SIZE;  k++)
                                        d[i][j][k] = s[i][j][k];
        return (timend ());
        }




/*
**      -- typical pointer reference.
*/

int cpptr (cnt)
        int cnt;
        {
        register char *sp, *dp;


        timestart ();
        for (  ;  cnt;  cnt--)
                {

/* !!! See how the compilers handle the &s[][][] in the loop. !!!       */

                dp = &d[0][0][0];
                sp = &s[0][0][0];
                while (sp <= &s[DIM_SIZE-1][DIM_SIZE-1][DIM_SIZE-1])
                        *dp++ = *sp++;
                }
        return (timend ());
        }

